<?php 

  if(!class_exists('WP_List_Table')){

    require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );

}

class NJT_LIST_TABLE_EMAIL extends WP_List_Table{

    private  $locale;

    function __construct(){

        global $status, $page;      

        //Set parent defaults

        parent::__construct( array(

            'singular'  => __( 'List Email', NJT_ABANDONED_CART ),    

            'plural'    => __( 'List Email', NJT_ABANDONED_CART ),    

            'ajax'      => false        

        ) );

       

    }

    function get_custom_post( $per_page = 5, $page_number = 1){

        global $wpdb,$post,$wp_query;

        $users = array();

        $args=array();

        

        $def=array(

          'paged' => $page_number,

          'posts_per_page' => $per_page,

          'post_type'=>'njt_list_email',

        );

        $arg_s_1 = array();

        if (!empty($_REQUEST['s'])) {

          $arg_s_1 =array(

              'relation' => 'OR',

                array( 

                    'key' => 'njt_email',

                    'value' =>$_REQUEST['s'],

                    'compare'=>'LIKE'

                  ),

               

              );

          }

      

        $args = array(

              'meta_query' => array(

                  'relation' => 'AND',

                  $arg_s_1,

            ),

        ); 

        $args = wp_parse_args($args,$def);

        $users  = new  WP_Query($args);

      return $users;

    }

    public function loops($users){

        $result = array();

        if($users->have_posts()){

        while ($users->have_posts()){

          $users->the_post();

          $result[]=get_post(get_the_id(),'ARRAY_A');

        }

      }

      return $result;

    }

    public function no_items() {

        _e( 'No Email avaliable.', NJT_ABANDONED_CART );

    }

    function column_cb($item){

        return sprintf(

            '<input type="checkbox" name="%1$s[]" value="%2$s" />',

            /*$1%s*/ $this->_args['singular'],  

            /*$2%s*/ $item['ID']                

        );

    }

    function column_id($item){

        return $item['ID'];

    }

    function column_cookie($item){



      return get_post_meta($item['ID'],'cookie_popup_br' ,true);

    }

    function column_email($item){

        return get_post_meta($item['ID'],'njt_email' ,true);

    }

    function column_product($item){

       

        $arr_product_quantity=unserialize(get_post_meta($item['ID'],'njt_email_product' ,true));

          if(get_post_meta($item['ID'],'njt_email_product' ,true)){

                  if(count($arr_product_quantity)>0){

                    foreach ($arr_product_quantity as $key => $product) {



                      if($product["product_id"]!=0 && $product["product_id"]!=-1 ){

                        $title=get_the_title($product["product_id"]);

                        $quantity=$product["quantity"];

                        $image_url = wp_get_attachment_image_src( get_post_thumbnail_id( $product["product_id"], "thumbnail" ))[0];

                        ?>

                        <p><img style="width: 20px;height: 20px;float: left;padding: 0 10px;" src="<?php echo $image_url; ?>"><?php echo $title.' X'.$quantity; ?></p>

                        <?php

                      }

                    }

                   

                  }

          }else{

            return "";

          }

    }

    function column_day($item){

      return get_the_date('m/d/Y',$item['ID']);

    }

    // GET FILEDS TABLE CUSTOM

    public function get_columns(){

        $columns = array(

            'cb'        => '<input type="checkbox" />',

            'id'    =>__('ID',NJT_ABANDONED_CART),

            //'cookie'=>__('Cookie',NJT_ABANDONED_CART),

            'email'=>__('Email',NJT_ABANDONED_CART),

            'product'=>__('Product',NJT_ABANDONED_CART),

            'day' =>__('Date',NJT_ABANDONED_CART),

        );

        return $columns;

    }

    // GET SHOW BULK ACTIONS

    public function get_bulk_actions() {

        $actions = array(

            'delete'    => __('Delete',NJT_ABANDONED_CART),

        );

        return $actions;

    }

    // PROCESS BULK ACTION CUSTOM

    public function process_bulk_action() {

        if ( 'delete' === $this->current_action() ) 

        {

          if((isset( $_GET['action']) && $_GET['action'] == 'delete')||isset( $_GET['action2']) && $_GET['action2'] == 'delete'){

            $delete_ids = esc_sql( $_GET['listemail'] );

        //    wp_die(print_r($delete_ids));

              foreach ( $delete_ids as $id ) {

            //    wp_die($id);

               //   self::delete_post( $id );

                  wp_delete_post($id);

              }

            wp_safe_redirect( add_query_arg( array( 'page' => 'njt-abandoned-cart-email' ), admin_url( 'admin.php' )));  

          }else{

            self::delete_post( absint( $_GET['listuser'] ));

            wp_safe_redirect( add_query_arg( array( 'page' => 'njt-abandoned-cart-email' ), admin_url( 'admin.php' )));

          }   

        }

    }

    // SHOW LIST CATEGORY EXTRA TABLE NAV ( SEARCH, FILTER, ...)

    public function extra_tablenav($which){

        if ($which == 'top') {

          ?>

         

          <?php

        }

    }

    public  function record_count(){

      $count =self::get_custom_post(-1);

      return $count->post_count;  

    }

    public  function column_default($item, $column_name)

    {

        return ((in_array($column_name, array_keys($this->get_columns()))) ? $item[$column_name] : print_r($item, true));

    }

    // SHOW TABLE CUSTOM

    public function prepare_items() {

        $per_page = $this->get_items_per_page('njt_per_page_mail', 20);

        $columns = $this->get_columns();

        $hidden = array();

        $sortable = $this->get_sortable_columns();

        $this->_column_headers = array($columns,$hidden,$sortable);  // SHOW COLUM FIELDS CUSTOM

        $this->process_bulk_action();

        $current_page = $this->get_pagenum(); 

        $total_items  = self::record_count();

        $loops = $this->get_custom_post($per_page,$current_page);

        $this->items = $this->loops($loops);

        $this->set_pagination_args( array(

            'total_items' => $total_items,                  

            'per_page'    => $per_page,       

        ) );

    }

}

?>