<?php 
/*
* Plugin Name: CartBack - Facebook Messenger Abandoned Cart & Remarketing for WooCommerce
* Plugin URI: https://ninjateam.org
* Description: Get your customers back & increase sales with Messenger automation
* Version: 2.8.1
* Author: 20script
* Author URI: https://www.20script.ir
* License: License GNU General Public License version 2 or later;
* Copyright 2018  Ninja_Team
*/

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
if(!class_exists('NJT_ABANDONED_CART_SETUP')):
	/**
	* 
	*/
update_option('license_cb_active', 'valid');
class NJT_ABANDONED_CART_SETUP
{
	function __construct()
	{		
			$this->define_constants();
			add_action('init',array(&$this,'check_plugin_defaults'));
			register_activation_hook(__FILE__, array($this, 'njt_abandoned_cart_create_databse'));
			register_deactivation_hook (__FILE__, array($this, 'njt_abandoned_cart_finish_cron_job'));
			$this->_includes_file();
			if(!function_exists('is_plugin_active'))
				include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
	}
	public function define_constants(){
		if(!defined('NJT_ABANDONED_CART')){
				define('NJT_ABANDONED_CART', 'njt-abandoned-cart');
		}
		if ( ! defined( 'NJT_ABANDONED_CART_VERSION' ) ){
				define( 'NJT_ABANDONED_CART_VERSION', '2.7' );
		}
		if ( ! defined( 'NJT_ABANDONED_CART_FOLDER' ) ) {
				define( 'NJT_ABANDONED_CART_FOLDER', plugin_basename( __FILE__ ) ); 
		}
		if ( ! defined( 'NJT_ABANDONED_CART_DIR' ) ) {
				define( 'NJT_ABANDONED_CART_DIR', plugin_dir_path( __FILE__ )  );
		}
		if ( ! defined( 'NJT_ABANDONED_CART_FILE' ) ) {
				define( 'NJT_ABANDONED_CART_FILE', __FILE__ );
		}
		if ( ! defined( 'NJT_ABANDONED_CART_INC' ) ) {
				define( 'NJT_ABANDONED_CART_INC', NJT_ABANDONED_CART_DIR.'includes'.'/' );
		}
		if ( ! defined( 'NJT_ABANDONED_CART_URL' ) ) {
				define( 'NJT_ABANDONED_CART_URL', plugin_dir_url( __FILE__ ) ); 
		}
		//
		if ( ! defined( 'NJT_ABANDONED_ENVATO_PRODUCT_ID' ) ){
				define( 'NJT_ABANDONED_ENVATO_PRODUCT_ID', "20852369" );
			}
		// languages
		$plugin_dir = basename(dirname(__FILE__));
 		load_textdomain("njt-abandoned-cart", NJT_ABANDONED_CART_DIR.'languages/'.get_option('WPLANG').'.mo' );
	}
	public function check_plugin_defaults(){
		//  Check woocommrce install & active,
		    if(!defined('WOOCOMMERCE_VERSION')){
					add_action('admin_notices', array(&$this,'njt_notice_woo'));
					return;
			}else{
					global $woocommerce;
					$currency = get_woocommerce_currency_symbol();
					update_option('njt_currency_symbol',$currency);
			}
			if( !wp_next_scheduled( 'first_reminder_cron_action' ) ) {  
     			wp_schedule_event( time(), 'first_reminder', 'first_reminder_cron_action' );  
	  		}
			if( !wp_next_scheduled( 'second_reminder_cron_action' ) ) {  
			     wp_schedule_event( time(), 'second_reminder', 'second_reminder_cron_action' );  
			}
			if( !wp_next_scheduled( 'third_reminder_cron_action' ) ) {  
			     wp_schedule_event( time(), 'third_reminder', 'third_reminder_cron_action' );  
			}
	// create custom post type list user add to cart	
			$label = array(
		        'name' => 'List User', 
		        'singular_name' => 'List User' 
		    );
		    $args = array(
		        'labels' => $label, 
		        'description' => 'List user', 
		        'supports' => array(
		            'title',
		            //'editor',
		            //'excerpt',
		           // 'author',
		            //'thumbnail',
		           // 'comments',
		            'trackbacks',
		            'revisions',
		            'custom-fields'
		        ), 
		      //  'taxonomies' => array( 'user_category'), 
		        'hierarchical' => false, 
		        'public' => true, 
		        'show_ui' => true, 
		        'show_in_menu' => false, // true 
		        'show_in_nav_menus' => false, 
		        'show_in_admin_bar' => false, 
		        'menu_position' => 5,
		        'menu_icon' => '',
		        'can_export' => false, 
		        'has_archive' => false, 
		        'exclude_from_search' => false, 
		        'publicly_queryable' => true,
		        'capability_type' => 'post' //
		    );
    		register_post_type('njt_user_add_to_cart', $args);
    // create custom post type list user click coupon -- update 3/6/2018
    		$label1 = array(
		        'name' => 'List User Get Email', 
		        'singular_name' => 'List User Email' 
		    );
		    $args1 = array(
		        'labels' => $label1, 
		        'description' => 'List user Get Email', 
		        'supports' => array(
		            'title',
		            //'editor',
		            //'excerpt',
		           // 'author',
		            //'thumbnail',
		           // 'comments',
		            'trackbacks',
		            'revisions',
		            'custom-fields'
		        ), 
		      //  'taxonomies' => array( 'user_category'), 
		        'hierarchical' => false, 
		        'public' => true, 
		        'show_ui' => true, 
		        'show_in_menu' => false, // true 
		        'show_in_nav_menus' => false, 
		        'show_in_admin_bar' => false, 
		        'menu_position' => 5,
		        'menu_icon' => '',
		        'can_export' => false, 
		        'has_archive' => false, 
		        'exclude_from_search' => false, 
		        'publicly_queryable' => true,
		        'capability_type' => 'post' //
		    );
    		register_post_type('njt_list_email', $args1);
    		//Alert Actice License
    		$check_active = -1;
			if(get_option("license_cb_active")){
				$license_cb_active = get_option("license_cb_active");
				$day_current = date('Y-m-d H:i:s',time());
				$supported_until = $license_cb_active["supported_until"];
				$check_active = strtotime($supported_until) - strtotime($day_current);
			}
			if($check_active < 0 ){
				delete_option("license_cb_active");
				delete_option("cartback_personal_token");
				add_action('admin_notices', array(&$this,'cb_active_license'));
			}
    		//
	}
	public function cb_active_license(){
		//$plugin = get_plugin_data(__FILE__);
		$url_license = add_query_arg(array('page'=>'njt-abandoned-cart-settings','tab'=>'product-license'),admin_url('admin.php'));
			echo '
				  <div class="notice notice-error is-dismissible"> <!-- calss default wordpress-->
				    <p>' . sprintf(__('Please activate CartBack license to use premium features. <a href="%s">Activate here</a>', NJT_ABANDONED_CART), $url_license) . '</p>
				  </div>';
	}
	public function njt_abandoned_cart_create_databse(){
		global $wpdb; // use query table
		$charset_collate = $wpdb->get_charset_collate();  // format language
		$table_user_ref = $wpdb->prefix.'user_ref_abandoned_cart';
		$table_statistical = $wpdb->prefix.'abandoned_cart_statistical';
		$table_user_add_cart = $wpdb->prefix.'abandoned_cart_user_add';
		$table_analystic = $wpdb->prefix.'abandoned_cart_analystic_fb';
		/***update 17-03-2018**/
		$table_shortcode = $wpdb->prefix.'abandoned_cart_shortcode';
		if ($wpdb->get_var("show tables like '$table_user_ref'") != $table_user_ref) {
			njt_abandoned_cart_create_DB($table_user_ref,$charset_collate);
		}else{
			$row_table_user_ref = $wpdb->get_col( "DESC " . $table_user_ref, 0 );
			//Add column if not present.
			if(!in_array('status_send_third', $row_table_user_ref)){
 				$wpdb->query("ALTER TABLE $table_user_ref ADD COLUMN `status_send_third` int(11) NOT NULL default 0 AFTER `status_send_second`");
 			}
 			if(!in_array('is_shortcode', $row_table_user_ref)){
 				$wpdb->query("ALTER TABLE $table_user_ref ADD COLUMN `is_shortcode` int(11) NOT NULL default 0 AFTER `status_send_third`");
 			}
		}
		if ($wpdb->get_var("show tables like '$table_statistical'") != $table_statistical) {
			njt_abandoned_cart_create_DB_statistical($table_statistical,$charset_collate);
		}else{
			$row_table_statistical = $wpdb->get_col( "DESC " . $table_statistical, 0 );
			//Add column if not present.
			if(!in_array('first_reminder_sent', $row_table_statistical)){
 				$wpdb->query("ALTER TABLE $table_statistical ADD COLUMN `first_reminder_sent` double NOT NULL DEFAULT 0 AFTER `send_user`,ADD COLUMN `second_reminder_sent` double NOT NULL DEFAULT 0 AFTER `first_reminder_sent`,ADD COLUMN `third_reminder_sent` double NOT NULL DEFAULT 0 AFTER `second_reminder_sent`");
 			}
 			//Add column if not present.
 			if(!in_array('coupon_user', $row_table_statistical)){
 				$wpdb->query("ALTER TABLE $table_statistical ADD COLUMN `coupon_user` double NOT NULL DEFAULT 0 AFTER `send_user`,ADD COLUMN `coupon_sent` double NOT NULL DEFAULT 0 AFTER `coupon_user`,ADD COLUMN `list_coupon_user` TEXT NULL AFTER `coupon_sent`,ADD COLUMN `shortcode_user` double NOT NULL DEFAULT 0 AFTER `list_coupon_user`,ADD COLUMN `shortcode_sent` double NOT NULL DEFAULT 0 AFTER `shortcode_user`,ADD COLUMN `list_shortcode_user` TEXT NULL AFTER `shortcode_sent`");	
 			}
		}
		if ($wpdb->get_var("show tables like '$table_user_add_cart'") != $table_user_add_cart) {
			njt_abandoned_cart_create_DB_User_Add_To_Cart($table_user_add_cart,$charset_collate);
		}
		if ($wpdb->get_var("show tables like '$table_analystic'") != $table_analystic) {
			njt_abandoned_cart_create_DB_Analystic_fb($table_analystic,$charset_collate);
		}else{
			$row_table_analystic = $wpdb->get_col( "DESC " . $table_analystic, 0 );
			//Add column if not present.
			if(!in_array('first_reminder', $row_table_analystic)){
 				$wpdb->query("ALTER TABLE $table_analystic ADD COLUMN `first_reminder` TEXT NULL AFTER `order_total_suc`,ADD COLUMN `second_reminder` TEXT NULL AFTER `first_reminder`,ADD COLUMN `third_reminder` TEXT NULL AFTER `second_reminder`");
 			}
		}	
		if ($wpdb->get_var("show tables like '$table_shortcode'") != $table_shortcode) {
			njt_abandoned_cart_create_DB_Shortcode($table_shortcode,$charset_collate);
		}else{
			$row_table_shortcode = $wpdb->get_col( "DESC " . $table_shortcode, 0 );
			//Add column if not present.
			if(!in_array('button_type', $row_table_shortcode)){
 				$wpdb->query("ALTER TABLE $table_shortcode ADD COLUMN `button_type` TEXT NULL AFTER `sub_title`,ADD COLUMN `message_type` TEXT NULL AFTER `button_type`,ADD COLUMN `text_type_cb` TEXT NULL AFTER `message_type`,ADD COLUMN `list_product` TEXT NULL AFTER `text_type_cb`,ADD COLUMN `message_cb` TEXT NULL AFTER `text_type_cb`");
 			}
 			if(!in_array('message_cb', $row_table_shortcode)){
 				$wpdb->query("ALTER TABLE $table_shortcode ADD COLUMN `message_cb` TEXT NULL AFTER `message`");
 			}
		}
		$table_campaign_send = $wpdb->prefix.'cartback_campaign';
		if ($wpdb->get_var("show tables like '$table_campaign_send'") != $table_campaign_send) {
	      	njt_cartback_create_DB_campaign($table_campaign_send,$charset_collate);    
		}
		//
		if(!get_option('njt_abandoned_cart_app_enable')){
			update_option('njt_abandoned_cart_app_enable',"on");
		}
	}
	public function njt_abandoned_cart_finish_cron_job(){
		// find out when the last event was scheduled
  		$timestamp1 = wp_next_scheduled ('first_reminder_cron_action');
		// unschedule previous event if any
		wp_unschedule_event ($timestamp1, 'first_reminder_cron_action');
  		// find out when the last event was scheduled
  		$timestamp2 = wp_next_scheduled ('second_reminder_cron_action');
  		// unschedule previous event if any
  		wp_unschedule_event ($timestamp2, 'second_reminder_cron_action');
  		$timestamp3 = wp_next_scheduled ('third_reminder_cron_action');
  		// unschedule previous event if any
  		wp_unschedule_event ($timestamp2, 'third_reminder_cron_action');
	}
	// Function Check Woo Install
	public function njt_notice_woo(){
			$plugin = get_plugin_data(__FILE__);
			echo '
				  <div class="error"> <!-- calss default wordpress-->
				    <p>' . sprintf(__('<strong>%s</strong> requires <strong><a href="https://vi.wordpress.org/plugins/woocommerce/" target="_blank">WooCommerce</a></strong> plugin to be installed and activated on your site.', NJT_ABANDONED_CART), $plugin['Name']) . '</p>
				  </div>';
	} 	
	public function _includes_file(){
		require(plugin_dir_path(__FILE__).'vendor/autoload.php');
		require(plugin_dir_path(__FILE__).'includes/facebook-api/api.php');
		// menu list user
	// create custom post type list user add to cart
		// call calback url (subscriber webhook)
		require(plugin_dir_path(__FILE__).'includes/facebook-api/rule.php');
		// https://preview.ninjateam.org/abandoned-cart-fb/callback?callback=webhook (callback url)
		require_once  NJT_ABANDONED_CART_INC.'posttype-add-to-cart-user.php';
		require_once  NJT_ABANDONED_CART_INC.'njt-post-list-email.php';
		//
		//envato
		require_once plugin_dir_path(__FILE__) . 'cartback-update/classess/class-njt-envato.php';
		if ( ! function_exists( 'njt_envato_market' ) ) :
			function njt_envato_market() {
				return NJT_ENVATO_MARKET::instance();
			}
		endif;
		njt_envato_market();
		// settings
		require NJT_ABANDONED_CART_INC.'settings.php';
		require NJT_ABANDONED_CART_INC.'functions.php';
		require NJT_ABANDONED_CART_INC.'cartback_reminder.php';
		require NJT_ABANDONED_CART_INC.'plugins.php';
		require NJT_ABANDONED_CART_INC.'ajax_cart.php';
	}
}
// CREATE TABLE   
if(!function_exists('njt_abandoned_cart_create_DB')){
	function njt_abandoned_cart_create_DB($table,$charset_collate){
	    $sql = 'CREATE TABLE '.$table.' (
		              `id` int(11) NOT NULL AUTO_INCREMENT,
		              `user_ref` TEXT NOT NULL,
		              `your_cart` TEXT NULL,
		              `session_key` VARCHAR(255) NOT NULL,
		              `status_send_first` int(11) NOT NULL default 0,
		              `status_send_second` int(11) NOT NULL default 0,
		              `status_send_third` int(11) NOT NULL default 0,
		              `is_shortcode` int(11) NOT NULL default 0,
		              `create_time` DATETIME NOT NULL, 
		              `update_time` DATETIME NOT NULL,
		               UNIQUE KEY id (id)
		              ) '.$charset_collate.';';
		require_once ABSPATH.'wp-admin/includes/upgrade.php';
		dbDelta($sql);
	}
}
if(!function_exists('njt_abandoned_cart_create_DB_statistical')){
	function njt_abandoned_cart_create_DB_statistical($table,$charset_collate){
		// list_user : recipient_id (array)
	    $sql = 'CREATE TABLE '.$table.' (
		              `id` int(11) NOT NULL AUTO_INCREMENT,
		              `user_test` double NOT NULL default 0,
		              `send_user` double NOT NULL default 0,
		              `coupon_user` double NOT NULL default 0,
		              `coupon_sent` double NOT NULL default 0,
		              `list_coupon_user` TEXT NULL,
		              `shortcode_user` double NOT NULL default 0,
		              `shortcode_sent` double NOT NULL default 0,
		              `list_shortcode_user` TEXT NULL,
		              `first_reminder_sent` double NOT NULL default 0,
		              `second_reminder_sent` double NOT NULL default 0,
		              `third_reminder_sent` double NOT NULL default 0,
		              `list_user` TEXT NULL,
		              `day` int(11) NOT NULL,
		              `month` int(11) NOT NULL,
		              `year` int(11) NOT NULL,
		              `date_statis` DATE NOT NULL, 
		               UNIQUE KEY id (id)
		              ) '.$charset_collate.';';
		require_once ABSPATH.'wp-admin/includes/upgrade.php';
		dbDelta($sql);
	}
}
if(!function_exists('njt_abandoned_cart_create_DB_Analystic_fb')){
	function njt_abandoned_cart_create_DB_Analystic_fb($table,$charset_collate){
		// list_user : recipient_id (array)
	    $sql = 'CREATE TABLE '.$table.' (
		              `id` int(11) NOT NULL AUTO_INCREMENT,
		              `count_user_click` double NOT NULL default 0,
		              `count_user_order` double NOT NULL default 0,
		              `order_total_suc` double NOT NULL default 0,
		              `first_reminder` TEXT NULL,
		              `second_reminder` TEXT NULL,
		              `third_reminder` TEXT NULL,
		              `arr_order` TEXT NULL,
		              `day` int(11) NOT NULL,
		              `month` int(11) NOT NULL,
		              `year` int(11) NOT NULL,
		              `date_statis` DATE NOT NULL, 
		               UNIQUE KEY id (id)
		              ) '.$charset_collate.';';
		require_once ABSPATH.'wp-admin/includes/upgrade.php';
		dbDelta($sql);
	}
}
if(!function_exists('njt_abandoned_cart_create_DB_User_Add_To_Cart')){
	function njt_abandoned_cart_create_DB_User_Add_To_Cart($table,$charset_collate){
	    $sql = 'CREATE TABLE '.$table.' (
		              `id` int(11) NOT NULL AUTO_INCREMENT,
		              `avatar` TEXT NOT NULL,
		              `first_name` VARCHAR(255) NOT NULL,
		              `last_name` VARCHAR(255) NOT NULL,
		              `gender` VARCHAR(255) NOT NULL,
		              `language` VARCHAR(255) NOT NULL,
		              `user_ref` TEXT NOT NULL,
		              `product_quantity` TEXT NULL,
		              `page` VARCHAR(255) NOT NULL,
		              `create_time` DATE NOT NULL, 
		               UNIQUE KEY id (id)
		              ) '.$charset_collate.';';
		require_once ABSPATH.'wp-admin/includes/upgrade.php';
		dbDelta($sql);
	}
}
if(!function_exists('njt_abandoned_cart_create_DB_Shortcode')){
	function njt_abandoned_cart_create_DB_Shortcode($table,$charset_collate){
	    $sql = 'CREATE TABLE '.$table.' (
		              `id` int(11) NOT NULL AUTO_INCREMENT,
		              `title` TEXT NULL,
		              `sub_title` TEXT NULL,
		              `button_type` TEXT NULL,
		              `message_type` TEXT NULL,
		              `text_type_cb` TEXT NULL,
		              `list_product` TEXT NULL,
		              `message` TEXT NULL,
		              `message_cb` TEXT NULL,
		               UNIQUE KEY id (id)
		              ) '.$charset_collate.';';
		require_once ABSPATH.'wp-admin/includes/upgrade.php';
		dbDelta($sql);
	}
}
if(!function_exists('njt_cartback_create_DB_campaign')){
	function njt_cartback_create_DB_campaign($table,$charset_collate){
		$sql = 'CREATE TABLE '.$table.' (
		              `id` int(11) NOT NULL AUTO_INCREMENT,
		              `campaign_key` TEXT NOT NULL,
		              `sent` double NOT NULL default 0,
		              `status` TEXT NULL,
		              `day` int(11) NOT NULL,
		              `month` int(11) NOT NULL,
		              `year` int(11) NOT NULL,
		              `date_campaign` DATE NULL,
		              `time_campaign` DATETIME NULL,
		               UNIQUE KEY id (id)
		              ) '.$charset_collate.';';
		require_once ABSPATH.'wp-admin/includes/upgrade.php';
		// time : month/day/year
		dbDelta($sql);
	}
}
endif;
new NJT_ABANDONED_CART_SETUP;